#include <windows.h>
#include <windowsx.h>

HINSTANCE g_hInstance = NULL;
TCHAR g_aszTexts[3][64];
HFONT g_hFont = NULL;

BOOL OnInitDialog(HWND hwnd, HWND hwndFocus, LPARAM lParam)
{
    for (INT i = 0; i < 3; ++i)
    {
        LoadString(g_hInstance, i, g_aszTexts[i], 64);
    }

    LOGFONT lf;
    ZeroMemory(&lf, sizeof(lf));
    lf.lfHeight = 20;
    lf.lfCharSet = DEFAULT_CHARSET;
    lstrcpy(lf.lfFaceName, TEXT("InvalidFontName"));

    g_hFont = CreateFontIndirect(&lf);
    return TRUE;
}

void OnPaint(HWND hwnd)
{
    PAINTSTRUCT ps;
    HDC hDC = BeginPaint(hwnd, &ps);
    if (hDC)
    {
        HGDIOBJ hFontOld = SelectObject(hDC, g_hFont);
        INT x = 20;
        INT y = 20;
        for (INT i = 0; i < 3; ++i)
        {
            TextOut(hDC, x, y, g_aszTexts[i], lstrlen(g_aszTexts[i]));
            y += 60;
        }
        {
            TCHAR szFace[LF_FACESIZE];
            GetTextFace(hDC, LF_FACESIZE, szFace);
            TextOut(hDC, x, y, szFace, lstrlen(szFace));
            y += 60;
        }
        {
            LOGFONT lf;
            GetObject(g_hFont, sizeof(lf), &lf);
            TextOut(hDC, x, y, lf.lfFaceName, lstrlen(lf.lfFaceName));
        }
        SelectObject(hDC, hFontOld);
        EndPaint(hwnd, &ps);
    }
}

void OnCommand(HWND hwnd, int id, HWND hwndCtl, UINT codeNotify)
{
    switch (id)
    {
    case IDOK:
        EndDialog(hwnd, IDOK);
        break;
    case IDCANCEL:
        EndDialog(hwnd, IDCANCEL);
        break;
    }
}

void OnDestroy(HWND hwnd)
{
    DeleteObject(g_hFont);
}

INT_PTR CALLBACK
DialogProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        HANDLE_MSG(hwnd, WM_INITDIALOG, OnInitDialog);
        HANDLE_MSG(hwnd, WM_PAINT, OnPaint);
        HANDLE_MSG(hwnd, WM_COMMAND, OnCommand);
        HANDLE_MSG(hwnd, WM_DESTROY, OnDestroy);
    }
    return 0;
}

INT WINAPI WinMain(
    HINSTANCE hInstance,
    HINSTANCE hPrevInstance,
    LPSTR lpCmdLine,
    INT nCmdShow)
{
    g_hInstance = hInstance;
    DialogBox(hInstance, MAKEINTRESOURCE(1), NULL, DialogProc);
    return 0;
}
